/**
 * Created by robin on 12/11/16.
 */

(function () {
    'use strict';
    angular.module('luticate2Utils')
        .factory('luDataAccess', ['$q', 'luRequest', function ($q, luRequest) {

            var luDataAccess = {};

            luDataAccess.create = function (entry_point) {
                var da = {};

                da.entry_point = entry_point;
                if (da.entry_point.substr(-1) !== '/') {
                    da.entry_point += '/';
                }

                da.get = function(url, dataGet, promise)
                {
                    return luRequest.get(da.entry_point + url, dataGet, promise);
                };

                da.post = function(url, dataGet, dataPost, promise)
                {
                    return luRequest.post(da.entry_point + url, dataGet, dataPost, promise);
                };

                da.put = function(url, dataGet, dataPost, promise)
                {
                    return luRequest.put(da.entry_point + url, dataGet, dataPost, promise);
                };

                da.delete = function(url, dataGet, dataPost, promise)
                {
                    return luRequest.delete(da.entry_point + url, dataGet, dataPost, promise);
                };

                return da;
            };

            return luDataAccess;

        }]);
})();