/**
 * Created by robin on 10/24/15.
 */

(function () {
    'use strict';
    angular.module('luticate2Utils')
        .factory('luRequest', ['$q', '$http', 'luBusyBusiness', function ($q, $http, luBusyBusiness) {

            var luRequest = {};

            luRequest.get = function(url, dataGet, luBusyDbo)
            {
                return luRequest.request(url, 'GET', dataGet, null, luBusyDbo);
            };

            luRequest.post = function(url, dataGet, dataPost, luBusyDbo)
            {
                return luRequest.request(url, 'POST', dataGet, dataPost, luBusyDbo);
            };

            luRequest.put = function(url, dataGet, dataPost, luBusyDbo)
            {
                return luRequest.request(url, 'PUT', dataGet, dataPost, luBusyDbo);
            };

            luRequest.delete = function(url, dataGet, dataPost, luBusyDbo)
            {
                return luRequest.request(url, 'DELETE', dataGet, dataPost, luBusyDbo);
            };

            function reject(deferred, data, status, luBusyDbo)
            {
                var obj = {
                    Data: data,
                    Status: status
                };
                deferred.reject(obj);
                if (luBusyDbo != null) {
                    luBusyBusiness.reject(luBusyDbo, obj);
                }
            }

            function resolve(deferred, data, luBusyDbo)
            {
                deferred.resolve(data);
                if (luBusyDbo != null) {
                    luBusyBusiness.resolve(luBusyDbo, data);
                }
            }

            luRequest.request = function(url, method, dataGet, dataPost, luBusyDbo)
            {
                if (luBusyDbo != null) {
                    luBusyBusiness.initLuBusy(luBusyDbo);
                }
                var deferred = $q.defer();

                url = url.replace(/\/+$/, '');

                var params = {
                    url: url,
                    method: method,
                    params: dataGet,
                    data: dataPost == null ? null : $.param(dataPost),
                    headers: {
                        'Content-Type': "application/json"
                    }
                };

                $http(params)
                    .success(function (result, status) {
                        if (result == null || result.Message != null) {
                            var message = result == null ? "Failed to parse response" : result.Message;
                            reject(deferred, message, status, luBusyDbo);
                        }
                        else {
                            resolve(deferred, result.Data, luBusyDbo);
                        }
                    })
                    .error(function (result, status) {
                        if (result == null || result.Message != null) {
                            var message = result == null ? "Failed to parse response" : result.Message;
                            reject(deferred, message, status, luBusyDbo);
                        }
                        else {
                            reject(deferred, result, status, luBusyDbo);
                        }
                    });
                return deferred.promise;
            };

            return luRequest;
        }]);
})();
